-- 5.1/itgm/outfox compat only!
if not PlayerOptions.ConfusionOffset then 
	SCREENMAN:SystemMessage('This file has mods that are not compatible with your version of StepMania! Please play on ITGMania/5.1/OutFox.')
	return {} 
end

local enablemods = {
GAMESTATE:GetCurrentSteps(0) and GAMESTATE:GetCurrentSteps(0):GetDifficulty() == 'Difficulty_Edit',
GAMESTATE:GetCurrentSteps(1) and GAMESTATE:GetCurrentSteps(1):GetDifficulty() == 'Difficulty_Edit'
}

local nomods = not enablemods[1] and not enablemods[2]
if nomods then return {} end

local showAFTs = true
if DISPLAY.SupportsRenderToTexture then
	if not DISPLAY:SupportsRenderToTexture() then
		showAFTs = false
	end
else
	if not string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'opengl')
	or string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'd3d')
	and string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'opengl') 
	and string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'd3d') < 
	string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'opengl') then
		showAFTs = false
	end
end

local sw = SCREEN_WIDTH
local sh = SCREEN_HEIGHT
local scx = SCREEN_CENTER_X
local scy = SCREEN_CENTER_Y
local dw = PREFSMAN:GetPreference('DisplayWidth')
local dh = PREFSMAN:GetPreference('DisplayHeight')
local dcx = dw/2
local dcy = dh/2
local zr = sw/dw
local rz = dw/sw

local styleName = GAMESTATE:GetCurrentStyle():GetName()

local comboProxies = {}
local pp = {}

checked = false
mod_plr = {}

FRAME_RATE = 60

-- EASING --
local path = GAMESTATE:GetCurrentSong():GetSongDir()..'lua/'
loadfile(path..'easing.lua')()
loadfile(path..'modhelpers.lua')()
loadfile(path.."mods.lua")()

flicker_value = 1

local function Plr(pn)
	if GAMESTATE:IsPlayerEnabled(pn-1) and enablemods[pn] then
		return SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
	else
		return nil
	end
end
function GetJud(pn)
	return _G['jud'..pn]
end
function GetCom(pn)
	return _G['com'..pn]
end

-- i am not taronuke
function mod_do(str,pn)
	if pn then
		if GAMESTATE:IsPlayerEnabled(pn-1) and enablemods[pn] then
			taronuke_mods(str,pn)
		end
	else
		for pn=1,2 do
			if GAMESTATE:IsPlayerEnabled(pn-1) and enablemods[pn] then
				taronuke_mods(str,pn)
			end
		end
	end
end


-- ALIASES --
--These make it so the syntax for the table entries matches the syntax for the nITG template.
--If you want to prefix all your calls with "modhelpers.", "ease.", etc., then you won't need this and can remove this section.
local linear, inQuad, outQuad, inOutQuad, outInQuad, inCubic, outCubic, inOutCubic, outInCubic, inQuart,outQuart, inOutQuart, outInQuart, inQuint, outQuint, inOutQuint, outInQuint, inSine, outSine, inOutSine,outInSine, inExpo, outExpo, inOutExpo, outInExpo, inCirc, outCirc, inOutCirc, outInCirc, inElastic,outElastic, inOutElastic, outInElastic, inBack, outBack, inOutBack, outInBack, inBounce, outBounce,inOutBounce, outInBounce = ease.linear, ease.inQuad, ease.outQuad, ease.inOutQuad, ease.outInQuad,ease.inCubic, ease.outCubic, ease.inOutCubic, ease.outInCubic, ease.inQuart, ease.outQuart,ease.inOutQuart, ease.outInQuart, ease.inQuint, ease.outQuint, ease.inOutQuint, ease.outInQuint,ease.inSine, ease.outSine, ease.inOutSine, ease.outInSine, ease.inExpo, ease.outExpo, ease.inOutExpo,ease.outInExpo, ease.inCirc, ease.outCirc, ease.inOutCirc, ease.outInCirc, ease.inElastic,ease.outElastic, ease.inOutElastic, ease.outInElastic, ease.inBack, ease.outBack, ease.inOutBack,ease.outInBack, ease.inBounce, ease.outBounce, ease.inOutBounce, ease.outInBounce

local perframe, mod_insert, mod2_insert, mod_ease, mod_perframe, mod_message, mod_blacklist, simple_m0d, simple_m0d2, simple_m0d3, mod_wiggle, mod_spring, mod_springt, mod_springt2, mod_spring_adjustable, mod_onebeat, switcfino_add, switcfino_reset, mod_sugarkiller, modulo, reverseRotation, randomXD, mod_bounce, ease_wiggle, ease_wiggleAbs, mod_flicker = modhelpers.perframe, modhelpers.mod_insert, modhelpers.mod2_insert, modhelpers.mod_ease, modhelpers.mod_perframe, modhelpers.mod_message, modhelpers.mod_blacklist, modhelpers.simple_m0d, modhelpers.simple_m0d2, modhelpers.simple_m0d3, modhelpers.mod_wiggle, modhelpers.mod_spring, modhelpers.mod_springt, modhelpers.mod_springt2, modhelpers.mod_spring_adjustable, modhelpers.mod_onebeat, modhelpers.switcfino_add, modhelpers.switcfino_reset, modhelpers.mod_sugarkiller, modhelpers.modulo,modhelpers.reverseRotation, modhelpers.randomXD, modhelpers.mod_bounce, modhelpers.ease_wiggle, modhelpers.ease_wiggleAbs, modhelpers.mod_flicker

local m = mod_insert
local m2 = mod_message
local me = mod_ease
local mb = mod_bounce
local mf = mod_flicker


local l = 'len'
local e = 'end'

init_modsp1 = ''
init_modsp2 = ''

mod_plr = {}

mod_firstSeenBeat = GAMESTATE:GetSongBeat() --necessary to prevent long freezes

-- thank u ky dashiel
local poptions = {GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song'), GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song')}
local isusingreverse = {false, false}
for pn = 1, 2 do
	if poptions[pn] then
		isusingreverse[pn] = poptions[pn]:Reverse() ~= 0
	end
end
		
			
---------------------------------------------------------------------------------------
----------------------Begin tables 'n stuff--------------------------------------------
---------------------------------------------------------------------------------------

--beat based mods
--{beat_start, beat_end, mods, len_or_end, player_number}
mods = {
	{0,9999,'*100000 2.5x, *1000 no beat, *1000 no confusionoffset, *1000 no tipsy, *1000 no drunk, *1000 no tornado, *1000 no invert, *1000 no flip, *1000 no tiny, *1000 no dizzy, *1000 dizzyholds, *1000 zbuffer, *1000 no stealth', 'end'},
}

--this is both a message broadcaster and a function runner
--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
--if you put {beat,function() somecode end}, then function() is run at that beat
--see example on beat 32

curaction = 1
--{beat,thing,persists}
mod_actions = {}

--beat-based ease mods
--{time_start, time_end, mod_start, mod_end, mod, len_or_end, ease_type, player_number, sustaintime, optional_param1, optional_param2}
--valid ease types are:
	--linear
	--inQuad    outQuad    inOutQuad    outInQuad
	--inCubic   outCubic   inOutCubic   outInCubic
	--inQuart   outQuart   inOutQuart   outInQuart
	--inQuint   outQuint   inOutQuint   outInQuint
	--inSine    outSine    inOutSine    outInSine
	--inExpo    outExpo    inOutExpo    outInExpo
	--inCirc    outCirc    inOutCirc    outInCirc
	--inElastic outElastic inOutElastic outInElastic    --can take 2 optional parameters - amplitude & period
	--inBack    outBack    inOutBack    outInBack       --can take 1 optional parameter  - spring amount
	--inBounce  outBounce  inOutBounce  outInBounce
	
mods_ease = {
	-- EXAMPLE TWEEN: from beat 0 to 4, make rotationz go from 360 to 0 with the inOutBack tween
	--{0,4,360,0,'rotationz','end',inOutBack},
}

mod_perframes = {	
}

function mpf(s,e,f)
	table.insert(mod_perframes,{s,e,f})
end

local h = SCREEN_HEIGHT / 480

-- garbage implementation of tweens as mods
local function rotx(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:rotationx(a)
		end
	end
end 
local function roty(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:rotationy(a)
		end
	end
end
local function rotz(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:rotationz(a)
		end
	end
end
local function zoom(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:zoom(a * h)
		end
	end
end
local function zoomx(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:zoomx(a * h)
		end
	end
end
local function zoomy(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:zoomy(a * h)
		end
	end
end
local function zoomz(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:zoomz(a)
		end
	end
end
-- probably not actually necessary
local function movez(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:z(a)
		end
	end
end
local function movey(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:y(a)
		end
	end
end
local function movex(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:x(a)
		end
	end
end
local function skewx(a)
	for pn = 1, 2 do
		local b = Plr(pn)
		if b then
			b:skewx(a)
		end
	end
end

function sor_vibro(a)
	for pn = 1,2 do
		local b = Plr(pn)
		local m = pn * 2 - 3
		if b then
			b:vibrate(1)
			b:effectmagnitude(a * m, a/8, 0)
		end
	end
end


-- misc functions
function modulo(a, b)
	return a - math.floor(a/b)*b;
end
function randomXD(t) -- getting a ton of mileage out of this function for 2 years thanks exschwasion
	if t == 0 then return 0.5 else
	return modulo(math.sin(t * 3229.3) * 43758.5453, 1) end
end

local function m_reverse(beat, dur, val)
	for pn = 1, 2 do
		local valn = isusingreverse[pn] and 100 - val or val
		m(beat, dur, '*10000 '..valn..' reverse', l, pn)
	end
end
local function me_reverse(beat, dur, start, stop, ease)
	for pn = 1, 2 do
		local startn = isusingreverse[pn] and 100 - start or start
		local stopn = isusingreverse[pn] and 100 - stop or stop
		me(beat, dur, startn, stopn, 'reverse', l, ease, pn)
	end
end
local function mb_reverse(beat, dur, start, stop, easeIn, easeOut)
	for pn = 1, 2 do
		local startn = isusingreverse[pn] and 100 - start or start
		local stopn = isusingreverse[pn] and 100 - stop or stop
		mb(beat, dur, startn, stopn, 'reverse', easeIn, easeOut, pn)
	end
end

local function spike(beat, dur, pre, start, stop, mod, ease, preEase)
	preEase = preEase or inExpo
	me(beat - pre, pre, start, stop, mod, l, preEase)
	me(beat, dur, stop, start, mod, l, ease)
end
local function sprike(beat, dur, pre, start, stop, realstop, mod, ease, preEase)
	preEase = preEase or inExpo
	me(beat - pre, pre, start, stop, mod, l, preEase)
	me(beat, dur, stop, realstop, mod, l, ease)
end
local function spikef(beat, dur, pre, start, stop, mod, ease, preEase)
	preEase = preEase or inExpo
	mf(beat - pre, pre, start, stop, mod, l, preEase)
	mf(beat, dur, stop, start, mod, l, ease)
end

local function apply(f)
  return function()
	  for pn = 1, 2 do
		local a = Plr(pn)
		if a then
		  f(a)
		end
	  end
  end
end

---------------------- MODS START
---------------------- Original by TaroNuke (UKSRT9 stage 3 - 131)

m2(0, apply(function(a) a:zoomz(3) end))

m(0, 27.5, '*10000 50 beat', l)
for i = 0, 1 do
    local o = 16 * i
	for j = 0, 3 do
		mb(4 + j + o, 1, 0, 80 * (j%2*2-1), 'drunk', outQuad, inQuad)
	end
end
me(28, 3, 0, 50, 'stealth', l, linear)
me(28, 3, 0, 20, 'brake', l, linear)
me(31, 1, 50, 0, 'stealth', l, inQuad)
me(31, 1, 20, 0, 'brake', l, inQuad)
me(28, 4, -628 * 3, 0, 'confusionoffset', l, inCirc)
me(32, 2, -628, 0, 'confusionoffset', l, outCirc)

me(32, 30.5, 0, 200, 'wave', l, linear)
me(32, 30.5, 0, 200, 'drunk', l, linear)
me(32, 30.5, 1, 0.5, zoom, l, linear)
me(62.5, 1.5, 200, 0, 'wave', l, outQuad)
me(62.5, 1.5, 200, 0, 'drunk', l, outQuad)

me(39,0.1,0,80,'stealth', l, outQuad, nil, 0.6)
me(39.7,0.4,80,0,'stealth', l, linear)
me(47,0.1,0,80,'stealth', l, outQuad, nil, 0.6)
me(47.7,0.4,80,0,'stealth', l, linear)
me(39,0.4,0,20,'brake', l, outQuad, nil, 0.3)
me(39.7,0.4,20,0,'brake', l, inQuad)
me(47,0.4,0,20,'brake', l, outQuad, nil, 0.3)
me(47.7,0.4,20,0,'brake', l, inQuad)

mod_onebeat(16, 200)
spike(16, 3, 0.25, 0, -50, 'tiny', outCubic)
mod_onebeat(32, 400)
mod_onebeat(40, -400)


for i=0,6 do
  m2(62.5+i*0.1666, function() zoom(0.5+0.5*((i+1)/7)) end)
end

m(63.5, 94.5, '*10000 200 beat', e)
m(95.5, 95.5+31, '*10000 200 beat', e)

for i = 0, 1 do
    local mult = i%2*2-1
    local o = 32 * i
	mpf(64+o, 94+o, function(beat)
		local pos = beat*math.pi
		mod_do('*10000 '..(-math.abs(64*math.sin(pos)))..' movey');
	end)
	mpf(68+o, 72+o, function(beat)
		local pos = beat*math.pi
		mod_do('*10000 '..(150*math.sin(pos))..' drunk');
	end)
	mpf(84+o, 88+o, function(beat)
		local pos = beat*math.pi
		mod_do('*10000 '..(150*math.sin(pos))..' drunk');
	end)
	mpf(76+o, 78+o, function(beat)
		local pos = beat*math.pi
		mod_do('*10000 '..(50*math.sin(pos))..' tipsy');
	end)
	m2(64+o, apply(function(a) 
		a:pulse();
		a:effectclock('bgm');
		a:effectperiod(1);
		a:effectmagnitude(1,1.2,0);
		a:effectcolor1(1.05,0.95,1,1);
		a:effectcolor2(0.96,1.03,1,1);
	end))
	m2(94+o,apply(function(a) a:stopeffect() end))
	mod_bounce(71.5-.1+o, 1, 0, 50, 'brake', outCirc, linear)
	mod_bounce(87.5-.1+o, 1, 0, 50, 'brake', outCirc, linear)
	m(87.5-.05+o,1,'*30 stealth',l)
	m(88-.05+o,1,'*30 no stealth',l)
	mod_bounce(78-.1+o, 1, 0, 40, rotx, outSine, inSine)
	mod_bounce(79-.1+o, 1, 0, -40, rotx, outSine, inSine)
	
	me(92+o, 0.2, 0, 30*mult, roty, l, outQuad)
	me(92.792+o, 0.2, 30*mult, -30*mult, roty, l, outQuad)
	me(92.792+.5+o, 0.2, -30*mult, 30*mult, roty, l, outQuad)
	me(92.792+1+o, 0.2, 30*mult, 0, roty, l, outQuad)
	
	m(94.5-.1+o,2,'*8 80 stealth','len')
end
m(96-.1,2,'*8 no stealth','len')
me(128,142.5,80,80,'stealth', e, linear)
me(140,4,80,0,'stealth', l, outQuad)

me(128, 14.5, 0, 100, 'wave', l, linear)
me(128, 14.5, 0, 100, 'drunk', l, linear)
me(128, 14.5, 1, 0.5, zoom, l, linear)
me(142.5, 1.5, 100, 0, 'wave', l, outQuad)
me(142.5, 1.5, 100, 0, 'drunk', l, outQuad)


local function eq_potato_inverter(beat,mod,many)
	for i=0,many-1 do
		m(beat+i,2,'*11 110 '..mod,'len')
		m(beat+i+.5,2,'*13 -10 '..mod,'len')
	end
end
local function eq_potato_screen_bounce(beat,zm,ang,backtime)
    local backtime = backtime or 0.5
	local backease = backtime and inQuad or linear
    me(beat,0.5,1,zm,zoom,l,outQuad)
    me(beat+0.5,backtime,zm,1,zoom,l,backease)
    me(beat,0.5,0,ang,rotz,l,outQuad)
    me(beat+0.5,backtime,ang,0,rotz,l,backease)
end

local viber = 0
m2(144, apply(function(a) a:vibrate() end))
mpf(144,174,function(beat) apply(function(a) a:effectmagnitude(viber,viber,0) end)() end)
m2(176, apply(function(a) a:stopeffect() end))
for i = 0, 3 do
  local mult = i%2*2-1
  eq_potato_inverter(144+i*8-.1,'flip',2)
  eq_potato_inverter(147+i*8-.1,'flip',2)
  m(149+i*8-.1,2,'*2 no flip',l)
  mb_reverse(146+8*i,1,0,-30,outQuad,inQuad)
  
  if i < 3 then
	  me(149+i*8,0.5,0,50*-mult,rotx,l,outQuad)
	  me(149.5+i*8,2,50*-mult,0,rotx,l,inOutQuad)
  end
  me(149+i*8,0.5,0,10,function(a) viber = a end,l,outQuad)
  me(149.5+i*8,2,10,0,function(a) viber = a end,l,outQuad)
  
  local int = 1+i*0.5
  local s = .8-(i/10)
  local fluct = 1
  for k=144,148 do
	local df = fluct
	local int2 = 1+i*0.5
	local s2 = .8-(i/10)
	eq_potato_screen_bounce(k+i*8,s2,5*df*int2)
	fluct = fluct*-1
  end
  local df = fluct
  eq_potato_screen_bounce(149+i*8,s,5*df*int,2)
end
mb_reverse(173.5,1,0,20,outQuad,inQuad)
mb_reverse(174.5,1,0,-10,outQuad,inQuad)
mb(173.5,1,0,1,skewx,outQuad,inQuad)
mb(174.5,1,0,-1,skewx,outQuad,inQuad)
me(175.5,1,0,0,skewx,l,linear)


mod_wiggle(204-.1,6,3,200,2,'drunk')
mod_wiggle(206.666-.1,4,3,130,2,'tipsy')

simple_m0d2(248.5-.1-72,50,.3,'stealth')
simple_m0d2(251.5-.1-72,50,.3,'stealth')
simple_m0d2(252.5-.1-72,50,.3,'stealth')
simple_m0d2(263.5-.1-72,50,.3,'stealth')
simple_m0d2(264.5-.1-72,50,.3,'stealth')
simple_m0d2(267.5-.1-72,50,.3,'stealth')
simple_m0d2(268.5-.1-72,50,.3,'stealth')
simple_m0d2(263-.1-72,100,.6,'stealth')

spike(235.5-72, 0.4, 0.1, 0, -30, 'tiny', outSine)
spike(234.0-72, 0.4, 0.1, 0, -30, 'tiny', outSine)
spike(234.5-72, 0.4, 0.1, 0, -30, 'tiny', outSine)
spike(235.0-72, 0.4, 0.1, 0, -30, 'tiny', outSine)
spike(269.5-72, 0.4, 0.1, 0, -30, 'tiny', outSine)
spike(270.0-72, 0.4, 0.1, 0, -30, 'tiny', outSine)
spike(270.5-72, 0.4, 0.1, 0, -30, 'tiny', outSine)
spike(271.0-72, 0.4, 0.1, 0, -30, 'tiny', outSine)

local eq_potato_switch = 1
local function eq_potato_switcher(beat)
  for col = 0, 3 do
    local mult = eq_potato_switch * (col%2*2-1)
	local startpos = beat == 175.5 and 0 or -eq_potato_switch * 150
	local endpos = beat == 202.5 and 0 or eq_potato_switch * 150
	me(beat-0.5, 0.5, startpos, mult * 100, 'movex'..col, l, inCubic)
	me(beat-0.3, 0.3, 0, 400, 'tiny'..col, l, inExpo)
	me(beat, 0.5, -mult * 100 + endpos, endpos, 'movex'..col, l, outCirc)
	me(beat, 0.3, 400, 0, 'tiny'..col, l, outExpo)
  end
  eq_potato_switch = -eq_potato_switch
end

eq_potato_switcher(175.5)
for i=0,6 do
    eq_potato_switcher(176.5+4*i)
    eq_potato_switcher(177.5+4*i)
    eq_potato_switcher(178.5+4*i)
end

me(177.5,0.5,3,10,zoomz,l,outQuad)
me(178,0.5,10,10,zoomz,l,linear)
me(178.5,0.5,10,3,zoomz,l,inQuad)

me_reverse(183, 0.83, 0, 100, inQuad)
me_reverse(183.83, 0.33, 100, 90, outQuad)
me_reverse(183.83+0.33, 0.33, 90, 100, inQuad)
me_reverse(183.83+0.67,6.5,100,100,linear)
me_reverse(191,0.83,100,0,inOutSine)
me_reverse(199, 0.83, 0, 100, inQuad)
me_reverse(199.83, 0.33, 100, 90, outQuad)
me_reverse(199.83+0.33, 0.33, 90, 100, inQuad)
me_reverse(199.83+0.67,35.5,100,100,linear)

mb(189,1,0,300,'drunk',outQuad,inQuad)
mb(190,1,0,-300,'drunk',outQuad,inQuad)

me(193.5,0.5,3,10,zoomz,l,outQuad)
me(194,0.5,10,10,zoomz,l,linear)
me(194.5,0.5,10,3,zoomz,l,inQuad)

local function shaker(start, dur, magnitude)
  mpf(start, start + dur, function(beat)
    local b = (beat-start)/dur
    local amount = math.cos(b*math.pi*3.5)/(1+b*3) * magnitude
    mod_do('*10000 '..amount..' dizzy')
    for col = 0, 3 do
      local mult = col%2*2-1
    mod_do('*10000 '..amount*mult..' movey'..col)
    end
  end)
end
me(176,32,0,0,'movey0',l,linear)
me(176,32,0,0,'movey1',l,linear)
me(176,32,0,0,'movey2',l,linear)
me(176,32,0,0,'movey3',l,linear)
shaker(179, 1.5, 60)
shaker(195, 1.5, -60)

me(187,1,1,0.5,zoom,l,outQuad)
me(188,0.5,0.5,1,zoom,l,inQuad)
me(203,1,1,0.5,zoom,l,outQuad)
me(204,2,0.5,1,zoom,l,inQuad)

me(187,1,0,-100,'invert',l,outQuad)
me(188,0.5,-100,0,'invert',l,inQuad)
me(203,1,0,-100,'invert',l,outQuad)
me(204,0.5,-100,0,'invert',l,inQuad)

mb(206,1,0,1,skewx,outQuad,inQuad)
mb(207,1,0,-1,skewx,outQuad,inQuad)
me(208,1,0,0,skewx,l,linear)

me(208,0.5,3,5,zoomz,l,inOutQuad)

for i = 208, 234, 2 do
  mod_onebeat(i, 1000*((i/2)%2*2-1))
end

local wob_pos = 0
for i = 0, 6 do
  mb(208+4*i,4,0,i%2*2-1,function(a) wob_pos = a end,linear,linear)
end
			
mpf(208,240,function(beat)
  for i=0,3,2 do
    mod_do('*10000 '..math.max(wob_pos * 200, 0)..' movex'..i);
    mod_do('*10000 '..(math.max(60*math.sin(wob_pos*math.pi),0))..' movez'..i);
  end
  for i=1,3,2 do
    mod_do('*10000 '..-math.max(-wob_pos * 200, 0)..' movex'..i);
    mod_do('*10000 '..(math.max(-60*math.sin(wob_pos*math.pi),0))..' movez'..i);
  end
end)

me_reverse(236,6,100,0,outCubic)
mod_bounce(222, 1, 0, 35, rotx, outSine, inSine)
mod_bounce(223, 1, 0, -35, rotx, outSine, inSine)

---------------------- MODS END

function modtable_compare(a,b)
	return a[1] < b[1]
end

if table.getn(mod_actions) > 1 then
	table.sort(mod_actions, modtable_compare)
end

local ac = Def.ActorFrame{
	Name= "xtl_actor_d",
	InitCommand=function(self)
		self:x(scx)
		self:y(scy)
	end,
}


ac[#ac+1] = Def.Actor{ OnCommand= function(s) mod_firstSeenBeat = GAMESTATE:GetSongBeat() s:sleep(9e9) end }
ac[#ac+1] = Def.Actor{
		
		OnCommand=function(s)
			s:queuecommand('Update')
		end,
		UpdateCommand=function(self)
			
			if GAMESTATE:GetSongBeat()>=0 and not checked then
			
				--name players, judgment and combo
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil
					if _G['P'..pn] then
						_G['jud'..pn] = _G['P'..pn]:GetChild('Judgment')
						_G['com'..pn] = _G['P'..pn]:GetChild('Combo')
					end
					
				end
				
				screen = SCREENMAN:GetTopScreen()
				checked = true --let this only run once
				
			end

			local beat = GAMESTATE:GetSongBeat()
			
			
---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false
			if disable ~= true and beat > mod_firstSeenBeat+0.1 and checked then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				for i=1,2 do
					--mod_do('clearall',i)
				end
				
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				for i,v in pairs(mods) do
					if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
						if beat >=v[1] then
							if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
								if table.getn(v) == 5 then
									mod_do(v[3],v[5])
								else
									mod_do(v[3])
								end
							end
						end
					else
						v[1] = 0
						v[2] = 0
						v[3] = ''
						v[4] = 'error'
						SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')')
					end
				end
				
				--------------------------------------------------------------------------------------
				-- i dont know who this reader is but he looks like he is made out of EASE HAHAHAHA --
				-- original code by exschwasion, bastardized by taro for cmod support and less 'if' --
				--------------------------------------------------------------------------------------
				for i,v in pairs(mods_ease) do
					if v and table.getn(v) > 6 and v[1] and v[2] and v[3] and v[4] and v[5] and v[6] and v[7] then
						if beat >=v[1] then
							if (v[6] == 'len' and beat <=v[1]+v[2]) or (v[6] == 'end' and beat <=v[2]) then
								
								local duration = v[2]
								if v[6] == 'end' then duration = v[2] - v[1] end
								local curtime = beat - v[1]
								local diff = v[4] - v[3]
								local startstrength = v[3]
								local curve = v[7]
								local mod = v[5]
								
								local strength = curve(curtime, startstrength, diff, duration, v[10], v[11]) --extra parameters for back and elastic eases :eyes:
								if v.flicker then strength = strength * flicker_value end
								
								if type(mod) == 'function' then
									mod(strength)
								else
									local modstr = v[5] == 'xmod' and strength..'x' or (v[5] == 'cmod' and 'C'..strength or strength..' '..v[5])
									mod_do('*10000 '..modstr,v[8]);
								end
								
							elseif (v[9] and ((v[6] == 'len' and beat <=v[1]+v[2]+v[9]) or (v[6] == 'end' and beat <=v[9]))) then
							
								local strength = v[4]
								if v.flicker then strength = strength * flicker_value end
								if type(mod) == 'function' then
									mod(strength)
								else
									local modstr = v[5] == 'xmod' and strength..'x' or (v[5] == 'cmod' and 'C'..strength or strength..' '..v[5])
									mod_do('*10000 '..modstr,v[8]);
								end
								
							end
						end
					else
						SCREENMAN:SystemMessage('Bad mod in beat-based ease table (line '..i..')')
					end
				end
				
				--------------------
				-- Perframe stuff --
				--------------------
				
				----------------------------------------
				-- HBLBHCBLBJGBHL DO THIS EVERY FRAME --
				----------------------------------------
				
				if table.getn(mod_perframes)>0 then
					for i=1,table.getn(mod_perframes) do
						local a = mod_perframes[i]
						if beat > a[1] and beat < a[2] then
							a[3](beat)
						end
					end
				end
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
					if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
						if type(mod_actions[curaction][2]) == 'function' then
							mod_actions[curaction][2]()
						elseif type(mod_actions[curaction][2]) == 'string' then
							MESSAGEMAN:Broadcast(mod_actions[curaction][2])
						end
					end
					curaction = curaction+1
				end
				
			end
			
			flicker_value = flicker_value * -1
			
			self:sleep(1/FRAME_RATE)
			self:queuecommand('Update')

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
	
	}

return ac